/* interpretor.h -- Simple Interpretor
   Copyright 2003 Free Software Foundation, Inc.
   Written by Stephane Carrez (stcarrez@nerim.fr)

This file is part of GEL.

GEL is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GEL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GEL; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef _GEL_INTERPRETOR_H
#define _GEL_INTERPRETOR_H

#include <sys/param.h>
#include <stddef.h>

#include "config.h"

#undef far
#define bank SECT_ATTR(".text.bank2")
#define far FAR_ATTR(".text.bank2")


/*! Persistent object class.

  
 */
class interpretor {

  // Execute the command (evaluate the expression).
  int bank execute(const char* line);

  // Busy loop to wait for a command or a valid number.
  void bank get_command (char *buf);
public:

  // Interpretor main loop.
  void far main_loop();
};

#endif
