/* Interrupt Vectors -- Bootstrap mode
   Copyright (C) 2000, 2001, 2002 Free Software Foundation, Inc.
   Written by Stephane Carrez (stcarrez@worldnet.fr)	

This file is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

In addition to the permissions in the GNU General Public License, the
Free Software Foundation gives you unlimited permission to link the
compiled version of this file with other programs, and to distribute
those programs without any restriction coming from the use of this
file.  (The General Public License restrictions do apply in other
respects; for example, they cover modification of the file, and
distribution when not linked into another program.)

This file is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifndef _M68HC11_ARCH_BOOTSTRAP_INTERRUPTS_H
#define _M68HC11_ARCH_BOOTSTRAP_INTERRUPTS_H

#define M68HC11_JMP 0x7e

extern inline void
set_interrupt_handler (interrupt_vector_id id, interrupt_t handler)
{
  unsigned char *p;

  /* Set interrupt handler for bootstrap mode.
     Compute address of that vector (3-bytes for each).
     Cast to unsigned short to avoid a Gcc warnings if sizeof int == 32.  */
  p = (unsigned char*) ((unsigned short) (0x100 - 3 * (RESET_VECTOR - id)));
  *p++ = M68HC11_JMP;
  ((interrupt_t*)p)[0] = handler;
}

#endif
