/* sys/sio.h -- Utility methods to read/write the SIO
   Copyright 2000 Free Software Foundation, Inc.
   Written by Stephane Carrez (stcarrez@worldnet.fr)

This file is part of GDB, GAS, and the GNU binutils.

GDB, GAS, and the GNU binutils are free software; you can redistribute
them and/or modify them under the terms of the GNU General Public
License as published by the Free Software Foundation; either version
1, or (at your option) any later version.

GDB, GAS, and the GNU binutils are distributed in the hope that they
will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this file; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef _SYS_SCI_H
#define _SYS_SCI_H

#include <sys/param.h>
#include <sys/ports.h>

#ifdef mc6811
# include <asm-m68hc11/sio.h>
#endif

#ifdef mc6812
# include <asm-m68hc12/sio.h>
#endif

#include <stddef.h>

extern void sci_initialize (unsigned char baud,
                            unsigned char *buffer,
                            size_t len);

extern void sci_putc (unsigned char c);

extern void sci_write (const unsigned char *data, size_t len);

extern int sci_read (unsigned char *data, size_t len, int mode);


#endif /* _SYS_SIO_H */

